=== debian/changelog ===
pyobjcryst (2.2.1-1build1) kinetic; urgency=medium

  * No-change rebuild to pick up fixed libboost-python dependencies

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 03 Sep 2022 13:17:42 +0000

pyobjcryst (2.2.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1003950: ITP: pyobjcryst -- Object-
    Oriented Crystallographic Library Python3 bindings)

 -- Neil Williams <codehelp@debian.org>  Wed, 02 Mar 2022 08:12:38 +0000
