=== debian/control ===
Source: pyobjcryst
Section: science
Priority: optional
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Neil Williams <codehelp@debian.org>,
 Picca Frédéric-Emmanuel <picca@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 python3-setuptools,
 python3-pkg-resources,
 python3-all,
 python3-numpy,
 scons,
 python3-all-dev,
 libboost-all-dev,
 libobjcryst-dev,
Standards-Version: 4.6.0
Homepage: https://github.com/diffpy/pyobjcryst
Vcs-Browser: https://salsa.debian.org/science-team/pyobjcryst
Vcs-Git: https://salsa.debian.org/science-team/pyobjcryst.git
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: python3-pyobjcryst
Architecture: amd64
Depends: python3-pkg-resources, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: python3-ipywidgets
Description: Object-Oriented Crystallographic Library bindings (Python 3)
 Python bindings to ObjCryst++, the Object-Oriented Crystallographic Library.
 .
 Some examples offer 3D support which can use python3-ipywidgets.
 .
 This package installs the library for Python 3.
