=== debian/changelog ===
pyobjcryst (2.2.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - Bump libobjcryst Build-Dep, it requires new APIs.
  * Refresh patches.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 08 Jan 2023 11:50:11 -0400

pyobjcryst (2.2.1-3) unstable; urgency=medium

  * Team upload.
  * Build for all supported Python 3 versions. (Closes: #1027012)
  * Run autopkgtest for all supported Python 3 versions.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 06 Jan 2023 23:10:38 -0400

pyobjcryst (2.2.1-2) unstable; urgency=medium

  * Team upload.
  * Patch: Pass --install-layout=deb to setup.py when scons calls it.
    (Closes: #1022382)

 -- Stefano Rivera <stefanor@debian.org>  Sat, 24 Dec 2022 15:38:27 -0400
