=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
 Uploaders:
- Neil Williams <codehelp@debian.org>,
+ Freexian Packaging Team <team+freexian@tracker.debian.org>,
  Picca Frédéric-Emmanuel <picca@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
@@ -15,7 +15,7 @@
  scons,
  python3-all-dev,
  libboost-all-dev,
- libobjcryst-dev,
+ libobjcryst-dev (>= 2022.1.4),
 Standards-Version: 4.6.0
 Homepage: https://github.com/diffpy/pyobjcryst
 Vcs-Browser: https://salsa.debian.org/science-team/pyobjcryst
