## pyobjcryst 2024.2.1

=== SConstruct ===
--- 
+++ 
@@ -52,7 +52,7 @@
 
 # copy system environment variables related to compilation
 DefaultEnvironment(ENV=subdictionary(os.environ, '''
-    PATH PYTHONPATH GIT_DIR
+    PATH PYTHONPATH GIT_DIR HOMEPATH HOMEDRIVE
     CPATH CPLUS_INCLUDE_PATH LIBRARY_PATH LD_RUN_PATH
     LD_LIBRARY_PATH DYLD_LIBRARY_PATH DYLD_FALLBACK_LIBRARY_PATH
     MACOSX_DEPLOYMENT_TARGET LANG
@@ -160,7 +160,7 @@
     env.AppendUnique(CPPDEFINES='BOOST_ALL_NO_LIB')
     # Prevent the generation of an import lib (.lib) in addition to the dll
     # env.AppendUnique(no_import_lib=1)
-    env.PrependUnique(CCFLAGS=['/Ox', '/EHsc', '/MD'])
+    env.PrependUnique(CCFLAGS=['/Ox', '/EHsc', '/MD', '/DREAL=double'])
     env.AppendUnique(CPPDEFINES={'NDEBUG': None})
 else:
     if 'CONDA_BUILD' not in os.environ:
@@ -192,6 +192,9 @@
     # Need this to avoid missing symbol with boost<1.66
     env.PrependUnique(CXXFLAGS=['-DBOOST_ERROR_CODE_HEADER_ONLY'])
 
+    # Use double precision for objcryst's REAL
+    env.PrependUnique(CCFLAGS=['-DREAL=double'])
+
     # Platform specific intricacies.
     if env['PLATFORM'] == 'darwin':
         darwin_shlinkflags = [n for n in env['SHLINKFLAGS'] if n != '-dynamiclib']
