=== debian/changelog ===
pyobjcryst (2024.2.1-2) unstable; urgency=medium

  * Team Upload
  * Drop build-dep on python3-pkg-resources, it's pulled by python3-setuptools
    (Closes: #1083578)
  * Use dh-sequence-python3
  * Bump Standards-Version to 4.7.2

  [ Michael R. Crusoe ]
  * d/rules: use DEB_BUILD_OPTION_PARALLEL instead of nproc
    to respect Debian Policy 4.9.1.

  [ Sébastien Delafond ]
  * Remove Freexian Packaging Team from uploaders

 -- Alexandre Detiste <tchet@debian.org>  Fri, 08 Aug 2025 10:49:53 +0200

pyobjcryst (2024.2.1-1) unstable; urgency=medium

  Update standards version to 4.6.2, no changes needed.
  * New upstream version 2024.2.1
  * Bug fix: "FTBFS: ModuleNotFoundError: No module named
    &#39;numpy.distutils&#39;", thanks to Santiago Vila (Closes:
    #1081092).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Mon, 25 Nov 2024 15:03:11 +0100
