=== debian/control ===
--- 
+++ 
@@ -3,20 +3,18 @@
 Priority: optional
 Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
 Uploaders:
- Freexian Packaging Team <team+freexian@tracker.debian.org>,
  Picca Frédéric-Emmanuel <picca@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
- dh-python,
+ dh-sequence-python3,
  python3-setuptools,
- python3-pkg-resources,
  python3-all,
  python3-numpy,
  scons,
  python3-all-dev,
  libboost-all-dev,
  libobjcryst-dev (>= 2022.1.4),
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/diffpy/pyobjcryst
 Vcs-Browser: https://salsa.debian.org/science-team/pyobjcryst
 Vcs-Git: https://salsa.debian.org/science-team/pyobjcryst.git
