=== debian/watch ===
version=4

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pyobjcryst-$1.tar.gz%" \
   https://github.com/diffpy/pyobjcryst/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
